<template>
  <v-form>
    <v-container fluid>
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.name"
            :error-messages="nameErrors"
            :label="$t('Nom')"
            @input="$v.item.name.$touch()"
            @blur="$v.item.name.$touch()"
          />
        </v-col>

        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model.number="item.price"
            :error-messages="priceErrors"
            :label="$t('Prix')"
            step="0.1"
            @input="$v.item.price.$touch()"
            @blur="$v.item.price.$touch()"
          />
        </v-col>

        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model.number="item.caution"
            :error-messages="cautionErrors"
            :label="$t('Caution')"
            step="0.1"
            @input="$v.item.caution.$touch()"
            @blur="$v.item.caution.$touch()"
          />
        </v-col>
      </v-row>

      <v-row>
        <v-col cols="6" sm="6" md="6">
          <v-text-field
            v-model="item.description"
            :error-messages="descriptionErrors"
            :label="$t('Description')"
            @input="$v.item.description.$touch()"
            @blur="$v.item.description.$touch()"
          />
        </v-col>
        <v-col cols="6">
          <v-list-item>
            <v-row no-gutters>
              <v-col cols="12">
                <v-list-item-avatar
                  v-if="computedImageUrls.length == 0"
                  tile
                  size="150"
                  color="grey"
                  rounded
                >
                  <v-img alt="Product image"></v-img>
                </v-list-item-avatar>
                <div
                  v-else
                  v-for="(imageUrl,index) in computedImageUrls"
                  :key="index"
                  style="position: relative; width: 150px;"
                >
                  <v-icon
                    @click="removeImage(imageUrl)"
                    style="background-color:red;text-decoration: none; color: white; position: absolute; top:0; right: 0; z-index: 50"
                  >mdi-close</v-icon>
                  <v-img
                    :src="imageUrl"
                    max-width="150"
                    max-height="150"
                    alt="Product image"
                    contain
                    style="border: 1px solid gray; background-color:white;"
                  ></v-img>
                </div>
              </v-col>
              <v-col cols="12">
                <v-list-item-content>
                  <v-file-input
                    v-model="images"
                    accept="image/*"
                    id="avatar"
                    label="Choisissez votre avatar"
                    name="avatar"
                    prepend-icon="mdi-camera"
                    multiple
                    counter="4"
                    @change="onFileChange"
                  ></v-file-input>
                </v-list-item-content>
              </v-col>
            </v-row>
          </v-list-item>
        </v-col>
      </v-row>

      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-checkbox
            v-model="item.isNew"
            :error-messages="isNewErrors"
            :label="$t('Nouveau')"
            @input="$v.item.isNew.$touch()"
            @blur="$v.item.isNew.$touch()"
          />
        </v-col>
      </v-row>

      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-combobox
            v-model="item.category"
            :items="categorySelectItems"
            :error-messages="categoryErrors"
            :no-data-text="$t('Pas de résultats')"
            :label="$t('Catégorie')"
            item-text="title"
            item-value="@id"
          />
        </v-col>

        <v-col cols="12"></v-col>
      </v-row>

      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-combobox
            v-model="item.store"
            :items="company.stores"
            :error-messages="storeErrors"
            :no-data-text="$t('Pas de résultats')"
            :label="$t('Magasin')"
            :item-text="fullLocation"
            item-value="@id"
          />
        </v-col>

        <v-col cols="12"></v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script>
import has from "lodash/has";
import { validationMixin } from "vuelidate";
import { ENTRYPOINT } from "../../../config/entrypoint";
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";

export default {
  name: "ProductForm",
  mixins: [validationMixin],
  props: {
    values: {
      type: Object,
      required: true
    },

    errors: {
      type: Object,
      default: () => {}
    },

    initialValues: {
      type: Object,
      default: () => {}
    },

    imageObjects: {
      type: Array,
      default: () => {}
    },

    productLoaded: {
      type: Boolean
    }
  },
  created() {
    if (this.userInfos) {
      this.getProfile(this.userInfos.id);
    }
  },
  mounted() {
    this.categoryGetSelectItems();
    if (this.productLoaded == true) {
      this.imageUrls = this.imageObjects.map(
        obj => ENTRYPOINT + "/media/" + obj.filePath
      );
    }
  },
  watch: {
    companyFound(newData) {
      if (newData) {
        this.getStoresByCompany(this.company.id);
      }
    },
    userInfos(newData) {
      if (newData) {
        this.getCompany(newData.company["@id"].split("/")[2]);
      }
    }
  },
  data() {
    return {
      name: null,
      price: null,
      caution: null,
      description: null,
      toAddImageUrls: [],
      imageUrls: [],
      notation: null,
      isNew: null,
      comments: null,
      stocks: null,
      composes: null,
      category: null,
      images: []
    };
  },
  computed: {
    computedImageUrls() {
      return this.toAddImageUrls.concat(this.imageUrls);
    },
    ...mapFields("comment", {
      commentsSelectItems: "selectItems"
    }),
    ...mapFields("stock", {
      stocksSelectItems: "selectItems"
    }),
    ...mapFields("compose", {
      composesSelectItems: "selectItems"
    }),
    ...mapFields("category", {
      categorySelectItems: "selectItems"
    }),
    ...mapFields("store", {
      storeSelectItems: "selectItems"
    }),
    ...mapFields("admin", ["company", "companyFound"]),
    ...mapFields("user", ["userInfos", "loggedIn"]),

    // eslint-disable-next-line
    item() {
      return this.initialValues || this.values;
    },

    nameErrors() {
      const errors = [];

      if (!this.$v.item.name.$dirty) return errors;

      has(this.violations, "name") && errors.push(this.violations.name);

      return errors;
    },
    priceErrors() {
      const errors = [];

      if (!this.$v.item.price.$dirty) return errors;

      has(this.violations, "price") && errors.push(this.violations.price);

      return errors;
    },
    descriptionErrors() {
      const errors = [];

      if (!this.$v.item.description.$dirty) return errors;

      has(this.violations, "description") &&
        errors.push(this.violations.description);

      return errors;
    },
    notationErrors() {
      const errors = [];

      if (!this.$v.item.notation.$dirty) return errors;

      has(this.violations, "notation") && errors.push(this.violations.notation);

      return errors;
    },
    isNewErrors() {
      const errors = [];

      if (!this.$v.item.isNew.$dirty) return errors;

      has(this.violations, "isNew") && errors.push(this.violations.isNew);

      return errors;
    },
    cautionErrors() {
      const errors = [];

      if (!this.$v.item.caution.$dirty) return errors;

      has(this.violations, "caution") && errors.push(this.violations.caution);

      return errors;
    },
    commentsErrors() {
      const errors = [];

      if (!this.$v.item.comments.$dirty) return errors;

      has(this.violations, "comments") && errors.push(this.violations.comments);

      return errors;
    },
    stocksErrors() {
      const errors = [];

      if (!this.$v.item.stocks.$dirty) return errors;

      has(this.violations, "stocks") && errors.push(this.violations.stocks);

      return errors;
    },
    composesErrors() {
      const errors = [];

      if (!this.$v.item.composes.$dirty) return errors;

      has(this.violations, "composes") && errors.push(this.violations.composes);

      return errors;
    },
    categoryErrors() {
      const errors = [];

      if (!this.$v.item.category.$dirty) return errors;

      has(this.violations, "category") && errors.push(this.violations.category);

      return errors;
    },
    storeErrors() {
      const errors = [];

      if (!this.$v.item.store.$dirty) return errors;

      has(this.violations, "store") && errors.push(this.violations.store);

      return errors;
    },

    violations() {
      return this.errors || {};
    }
  },
  methods: {
    ...mapActions({
      commentsGetSelectItems: "comment/fetchSelectItems"
    }),
    ...mapActions({
      stocksGetSelectItems: "stock/fetchSelectItems"
    }),
    ...mapActions({
      composesGetSelectItems: "compose/fetchSelectItems"
    }),
    ...mapActions({
      categoryGetSelectItems: "category/fetchSelectItems"
    }),
    ...mapActions("admin", ["getCompany", "getStoresByCompany"]),
    ...mapActions("user", ["getProfile"]),
    fullLocation: item =>
      item.street + " - " + item.zc + item.city + ", " + item.country,
    onFileChange() {
      this.toAddImageUrls = [];
      this.images.forEach(image =>
        this.toAddImageUrls.push(URL.createObjectURL(image))
      );
      this.$emit("on-images-changed", this.images);
    },
    removeImage(imageUrl) {
      if (this.toAddImageUrls.find(iUrl => iUrl == imageUrl)) {
        this.images.splice(this.toAddImageUrls.indexOf(imageUrl), 1);
        this.toAddImageUrls.splice(this.toAddImageUrls.indexOf(imageUrl), 1);
      }
      if (this.imageObjects !== undefined) {
        if (
          this.imageObjects.find(
            imageObj => ENTRYPOINT + "/media/" + imageObj.filePath == imageUrl
          )
        ) {
          this.imageObjects.splice(
            this.imageObjects.indexOf(
              this.imageObjects.find(
                imageObj =>
                  ENTRYPOINT + "/media/" + imageObj.filePath == imageUrl
              )
            ),
            1
          );
          this.imageUrls.splice(this.imageUrls.indexOf(imageUrl), 1);
        }
      }
      this.$emit("on-images-removed", this.imageObjects, this.images);
    }
  },
  validations: {
    item: {
      name: {},
      price: {},
      caution: {},
      description: {},
      notation: {},
      isNew: {},
      comments: {},
      stocks: {},
      composes: {},
      category: {},
      store: {}
    }
  }
};
</script>